﻿Import-Module WebAdministration

$ErrorActionPreference = "stop"

if(Test-Path 'iis:\sites\AosService')
{
    $webroot = $(get-item 'iis:\sites\AosService')
    Stop-WebSite 'AosService'
    if((Get-WebAppPoolState 'AOSService').Value -ne 'Stopped') 
    {
        Stop-WebAppPool 'AOSService'
    }
}
else
{
    $webroot = $(get-item 'iis:\sites\AosWebApplication')
    Stop-WebSite 'AosWebApplication'

    if((Get-WebAppPoolState 'AOSAppPool').Value -ne 'Stopped') 
    {
        Stop-WebAppPool 'AOSAppPool'
    }
}

try
{
    Get-Process xppc* | Stop-Process -Force
}
catch
{}

if (Get-Service | where Name -eq DynamicsAxBatch)
{
    Set-Service DynamicsAxBatch -startupType Disabled
    Stop-Service DynamicsAxBatch
    Write-Output "Batch service stopped."
}

$file = Resolve-Path "$($webroot.PhysicalPath)\bin\AOSKernel.dll"

$fileLocked = $true

while($fileLocked)
{
    try 
    { 
    [IO.File]::OpenWrite($file).close()
    $fileLocked = $false 
    }
    catch {}
}

Write-Output "Aos service stopped."

